/* AMX Mod X
*   Armoury Respawner
*
* (c) Copyright 2006 by VEN
*
* This file is provided as is (no warranties)
*
*     DESCRIPTION
*       Plugin respawns the armoury_entities (map's ground weapons) after its collection.
*       The respawn time is controlled by the amx_armoury_respawntime CVAR value (seconds).
*/

#include <amxmodx>
#include <fakemeta>

#define PLUGIN_NAME "Armoury Respawner"
#define PLUGIN_VERSION "0.1"
#define PLUGIN_AUTHOR "VEN"

new const g_armoury_entity[] = "armoury_entity"

new g_pcvar_armoury_respawntime

public plugin_precache() {
	register_plugin(PLUGIN_NAME, PLUGIN_VERSION, PLUGIN_AUTHOR)

	register_forward(FM_Touch, "forward_touch")
	register_forward(FM_Think, "forward_think")

	g_pcvar_armoury_respawntime = register_cvar("amx_armoury_respawntime", "30")
}

public forward_touch(ent) {
	if (is_armoury_entity(ent) && (pev(ent, pev_effects) & EF_NODRAW)) {
		static Float:nextthink
		pev(ent, pev_nextthink, nextthink)
		if (!nextthink)
			set_pev(ent, pev_nextthink, get_gametime() + get_pcvar_num(g_pcvar_armoury_respawntime))
	}
}

public forward_think(ent) {
	if (is_armoury_entity(ent)) {
		dllfunc(DLLFunc_Spawn, ent)
		set_pev(ent, pev_effects, pev(ent, pev_effects) & ~EF_NODRAW)
	}
}

bool:is_armoury_entity(ent) {
	if (!pev_valid(ent))
		return false

	static classname[sizeof g_armoury_entity + 1]
	pev(ent, pev_classname, classname, sizeof g_armoury_entity)
	if (equal(classname, g_armoury_entity))
		return true

	return false
}
